/****************************************Copyright (c)****************************************************
**                                      
**                                 http://www.powermcu.com
**
**--------------File Info---------------------------------------------------------------------------------
** File name:               main.c
** Descriptions:            The Camera (CF7670C-V2) application function
**
**--------------------------------------------------------------------------------------------------------
** Created by:              AVRman
** Created date:            2011-2-13
** Version:                 v1.0
** Descriptions:            The original version
**
**--------------------------------------------------------------------------------------------------------
** Modified by:             
** Modified date:           
** Version:                 
** Descriptions:            
**
*********************************************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "GLCD.h"
#include "OV7670.h"


/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
int main(void)
{ 
  LCD_Initializtion();

  FIFO_GPIO_Configuration();
  FIFO_CS_L();

  FIFO_WE_H();
  while( 1 != Sensor_Init() );
  
  OV7670_EXTI_Configuration();
  OV7670_NVIC_Configuration();  

  Vsync = 0;

  /* Infinite loop */
  while (1)
  {	 
    uint32_t count;
    uint16_t CMOS_Data;

    if( Vsync == 2 )
    {
       LCD_SetCursor(0, 319);
       LCD_WriteRAM_Prepare(); /* Prepare to write GRAM */  
       FIFO_RRST_L(); 
       FIFO_RCLK_L();
   
       FIFO_RCLK_H();
       FIFO_RRST_H();
       FIFO_RCLK_L();
    
       FIFO_RCLK_H();
       
	   for( count = 0; count < 76800; count++ )
        {
          FIFO_RCLK_L(); 

          CMOS_Data = (GPIOC->IDR<<8) & 0xff00;	  /* ( GPIO_ReadInputData(GPIOC) << 8 ) & 0xff00; */
          FIFO_RCLK_H();
           
          FIFO_RCLK_L();
          CMOS_Data |= (GPIOC->IDR) & 0x00ff;	  /* ( GPIO_ReadInputData(GPIOC) ) & 0x00ff; */
          FIFO_RCLK_H();  

          LCD_WriteRAM(CMOS_Data);
         }
         Vsync = 0;
       }	    
  }
}



#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*********************************************************************************************************
      END FILE
*********************************************************************************************************/
